

# UpdateMatchingWorkflow
<a name="API_UpdateMatchingWorkflow"></a>

Updates an existing matching workflow. The workflow must already exist for this operation to succeed.

**Important**  
For workflows where `resolutionType` is `ML_MATCHING` or `PROVIDER`, incremental processing is not supported. 

## Request Syntax
<a name="API_UpdateMatchingWorkflow_RequestSyntax"></a>

```
PUT /matchingworkflows/workflowName HTTP/1.1
Content-type: application/json

{
   "description": "string",
   "incrementalRunConfig": { 
      "incrementalRunType": "string"
   },
   "inputSourceConfig": [ 
      { 
         "applyNormalization": boolean,
         "inputSourceARN": "string",
         "schemaName": "string"
      }
   ],
   "outputSourceConfig": [ 
      { 
         "applyNormalization": boolean,
         "customerProfilesIntegrationConfig": { 
            "domainArn": "string",
            "objectTypeArn": "string"
         },
         "KMSArn": "string",
         "output": [ 
            { 
               "hashed": boolean,
               "name": "string"
            }
         ],
         "outputS3Path": "string"
      }
   ],
   "resolutionTechniques": { 
      "providerProperties": { 
         "intermediateSourceConfiguration": { 
            "intermediateS3Path": "string"
         },
         "providerConfiguration": JSON value,
         "providerServiceArn": "string"
      },
      "resolutionType": "string",
      "ruleBasedProperties": { 
         "attributeMatchingModel": "string",
         "matchPurpose": "string",
         "rules": [ 
            { 
               "matchingKeys": [ "string" ],
               "ruleName": "string"
            }
         ]
      },
      "ruleConditionProperties": { 
         "rules": [ 
            { 
               "condition": "string",
               "ruleName": "string"
            }
         ]
      }
   },
   "roleArn": "string"
}
```

## URI Request Parameters
<a name="API_UpdateMatchingWorkflow_RequestParameters"></a>

The request uses the following URI parameters.

 ** [workflowName](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-uri-workflowName"></a>
The name of the workflow to be retrieved.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[a-zA-Z_0-9-]*`   
Required: Yes

## Request Body
<a name="API_UpdateMatchingWorkflow_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [description](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-description"></a>
A description of the workflow.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 255.  
Required: No

 ** [incrementalRunConfig](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-incrementalRunConfig"></a>
Optional. An object that defines the incremental run type. This object contains only the `incrementalRunType` field, which appears as "Automatic" in the console.   
For workflows where `resolutionType` is `ML_MATCHING` or `PROVIDER`, incremental processing is not supported. 
Type: [IncrementalRunConfig](API_IncrementalRunConfig.md) object  
Required: No

 ** [inputSourceConfig](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-inputSourceConfig"></a>
A list of `InputSource` objects, which have the fields `InputSourceARN` and `SchemaName`.  
Type: Array of [InputSource](API_InputSource.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 20 items.  
Required: Yes

 ** [outputSourceConfig](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-outputSourceConfig"></a>
A list of `OutputSource` objects, each of which contains fields `outputS3Path`, `applyNormalization`, `KMSArn`, and `output`.  
Type: Array of [OutputSource](API_OutputSource.md) objects  
Array Members: Fixed number of 1 item.  
Required: Yes

 ** [resolutionTechniques](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-resolutionTechniques"></a>
An object which defines the `resolutionType` and the `ruleBasedProperties`.  
Type: [ResolutionTechniques](API_ResolutionTechniques.md) object  
Required: Yes

 ** [roleArn](#API_UpdateMatchingWorkflow_RequestSyntax) **   <a name="API-UpdateMatchingWorkflow-request-roleArn"></a>
The Amazon Resource Name (ARN) of the IAM role. AWS Entity Resolution assumes this role to create resources on your behalf as part of workflow execution.  
Type: String  
Required: Yes

## Response Syntax
<a name="API_UpdateMatchingWorkflow_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "description": "string",
   "incrementalRunConfig": { 
      "incrementalRunType": "string"
   },
   "inputSourceConfig": [ 
      { 
         "applyNormalization": boolean,
         "inputSourceARN": "string",
         "schemaName": "string"
      }
   ],
   "outputSourceConfig": [ 
      { 
         "applyNormalization": boolean,
         "customerProfilesIntegrationConfig": { 
            "domainArn": "string",
            "objectTypeArn": "string"
         },
         "KMSArn": "string",
         "output": [ 
            { 
               "hashed": boolean,
               "name": "string"
            }
         ],
         "outputS3Path": "string"
      }
   ],
   "resolutionTechniques": { 
      "providerProperties": { 
         "intermediateSourceConfiguration": { 
            "intermediateS3Path": "string"
         },
         "providerConfiguration": JSON value,
         "providerServiceArn": "string"
      },
      "resolutionType": "string",
      "ruleBasedProperties": { 
         "attributeMatchingModel": "string",
         "matchPurpose": "string",
         "rules": [ 
            { 
               "matchingKeys": [ "string" ],
               "ruleName": "string"
            }
         ]
      },
      "ruleConditionProperties": { 
         "rules": [ 
            { 
               "condition": "string",
               "ruleName": "string"
            }
         ]
      }
   },
   "roleArn": "string",
   "workflowName": "string"
}
```

## Response Elements
<a name="API_UpdateMatchingWorkflow_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [description](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-description"></a>
A description of the workflow.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 255.

 ** [incrementalRunConfig](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-incrementalRunConfig"></a>
An object which defines an incremental run type and has only `incrementalRunType` as a field.  
Type: [IncrementalRunConfig](API_IncrementalRunConfig.md) object

 ** [inputSourceConfig](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-inputSourceConfig"></a>
A list of `InputSource` objects, which have the fields `InputSourceARN` and `SchemaName`.  
Type: Array of [InputSource](API_InputSource.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 20 items.

 ** [outputSourceConfig](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-outputSourceConfig"></a>
A list of `OutputSource` objects, each of which contains fields `outputS3Path`, `applyNormalization`, `KMSArn`, and `output`.  
Type: Array of [OutputSource](API_OutputSource.md) objects  
Array Members: Fixed number of 1 item.

 ** [resolutionTechniques](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-resolutionTechniques"></a>
An object which defines the `resolutionType` and the `ruleBasedProperties`.  
Type: [ResolutionTechniques](API_ResolutionTechniques.md) object

 ** [roleArn](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-roleArn"></a>
The Amazon Resource Name (ARN) of the IAM role. AWS Entity Resolution assumes this role to create resources on your behalf as part of workflow execution.  
Type: String

 ** [workflowName](#API_UpdateMatchingWorkflow_ResponseSyntax) **   <a name="API-UpdateMatchingWorkflow-response-workflowName"></a>
The name of the workflow.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[a-zA-Z_0-9-]*` 

## Errors
<a name="API_UpdateMatchingWorkflow_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.   
HTTP Status Code: 403

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Entity Resolution service.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The resource couldn't be found.   
HTTP Status Code: 404

 ** ThrottlingException **   
The request was denied due to request throttling.   
HTTP Status Code: 429

 ** ValidationException **   
The input fails to satisfy the constraints specified by AWS Entity Resolution.   
HTTP Status Code: 400

## See Also
<a name="API_UpdateMatchingWorkflow_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/entityresolution-2018-05-10/UpdateMatchingWorkflow) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/entityresolution-2018-05-10/UpdateMatchingWorkflow) 